#property copyright "Expert for tests"

extern double Lots = 0.1 ;
extern int max_trades = 10 ; // max. open orders
extern int grid_lines = 10 ; // Pips distance of lines
extern double RangeMid = 1.2991 ;
extern double grid_separation = 0.0010 ;
extern double TP = 11 ;
extern int slip = 3 ;

int BarCount;
int Current;
bool TickCheck = False;
bool OrderinMarket = false; // Variable that checks if order is already in the market.

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
 
   int Entertradebuy =0 ;
   int Entertradesell =0 ;
   double level ;
 
   if(OrdersTotal()==0)
   GlobalVariableSet("level", 0) ; 
    level=GlobalVariableGet("level") ;
   if(OrdersTotal()<max_trades)
   {
  for (int i = 1; i<grid_lines; i++)   
   {
   if (Ask == RangeMid - grid_separation*i && level != RangeMid - grid_separation*i)
   {
   GlobalVariableSet("level", RangeMid - grid_separation*i) ;
   Entertradebuy=1 ;
   }
   if (Bid == RangeMid + grid_separation*i && level != RangeMid + grid_separation*i)
   {
   GlobalVariableSet("level", RangeMid + grid_separation*i) ;
   Entertradesell=1 ; 
   Print(i);
   }
   }
   }
  
// Check if there is already an order in market with that price
// Feststellen ob zum Preis schon eine offene Order existiert
for(int ij = 0; ij < OrdersTotal( ); ij++)
   if(OrderSelect(ij, SELECT_BY_POS, MODE_TRADES) == true) {
      if(OrderSymbol() == Symbol())
         if(OrderOpenPrice() == Ask)
            OrderinMarket = true;
    } else {
            OrderinMarket = false;
    }
// - End check order in market ----------------------

   if(Entertradebuy==1  && OrderinMarket==false)
   {
   double Ticket1 = OrderSend(Symbol(), OP_BUY, Lots, Ask, slip, 0, Ask+TP*Point, "Buy(#" + 1 + ")", 1, 0, DodgerBlue) ;         
   }
      
   if(Entertradesell==1  && OrderinMarket==false)
   {
   double Ticket2 = OrderSend(Symbol(), OP_SELL, Lots, Bid, slip, 0, Bid-TP*Point, "Sell(#" + 1 + ")", 1, 0, DeepPink) ;
   }
   
for (i = 1; i<grid_lines; i++)
{
if(Ask - (RangeMid - grid_separation*i) < grid_separation && level != RangeMid - grid_separation*i)
GlobalVariableSet("next_level", RangeMid - grid_separation*i) ;
if(RangeMid + grid_separation*i - Bid < grid_separation && level != RangeMid + grid_separation*i)
GlobalVariableSet("next_level", RangeMid + grid_separation*i) ;
}

double next_level=GlobalVariableGet("next_level") ;

if(OrdersTotal() < max_trades)
Comment("I am trading a grid from ", RangeMid-grid_separation*grid_lines, " to ", RangeMid+grid_separation*grid_lines, "\n",
        "closest grid line to enter trade is ", next_level , "\n", 
        "distance between grid lines is ", grid_separation*10000, " pips", "\n",
        "number of grid lines is ", grid_lines, "\n",
        "maximum number of open trades is ", max_trades, "\n",
        "TP is ", TP) ;     
        
if(OrdersTotal() >= max_trades)
Comment("I am full, I have ", max_trades, " positions opened");
     
   return(0);
}
//+------------------------------------------------------------------+
